class apache::modsecurity (
  $packagename_modsecurity     = $::apache::params::packagename_modsecurity,
  $configfile_modsecurity      = $::apache::params::configfile_modsecurity,
  $template_modsecurity        = 'apache/modsecurity.erb',
  $loadmodule                  = [],
  $includeoptional             = [],
  $include                     = [],
  $secruleengine               = undef,
  $secrequestbodyaccess        = undef,
  $secrequestbodylimit         = undef,
  $secrequestbodynofileslimit  = undef,
  $secrequestbodyinmemorylimit = undef,
  $secrequestbodylimitaction   = undef,
  $secpcrematchlimit           = undef,
  $secpcrematchlimitrecursion  = undef,
  $secresponsebodyaccess       = undef,
  $secdebuglog                 = undef,
  $secdebugloglevel            = undef,
  $secauditengine              = undef,
  $secauditlogrelevantstatus   = undef,
  $secauditlogparts            = undef,
  $secauditlogtype             = undef,
  $secauditlog                 = undef,
  $secargumentseparator        = undef,
  $seccookieformat             = undef,
  $sectmpdir                   = undef,
  $secdatadir                  = undef,
  $secresponsebodymimetype     = undef,
  $secresponsebodylimit        = undef,
  $secresponsebodylimitaction  = undef,
  $secunicodemapfile           = undef,
  $secstatusengine             = undef,
) inherits ::apache::params {
  package { $packagename_modsecurity: ensure => installed }
  file { $configfile_modsecurity:
    require => package[$packagename_modsecurity],
    backup  => '.backup',
    content => template($template_modsecurity),
  }
}
